// --- Saved variables ---
// You can add what you want to the save
savedInt 		= 0; // Here is the initialization for the first launch, after that the value will depend on what has been saved
niflheimAttack 		= 1.0;
spawnCount 		= 1.0;
chief 		= 1;
halvard 		= 1;

function saveState() {
	state.scriptProps = {
		savedInt 		: savedInt,
		niflheimAttack 		: niflheimAttack,
		spawnCount 		: spawnCount,
		chief 		: chief,
		halvard 		: halvard,
	}
}


// --- Local variables ---
var localInt 				= 3;
var Village = [91, 84];
var WolfDen = getZone(78);
var Niflheim = [getZone(71), getZone(52)];
var AdventureSpawn = [getZone(96), getZone(80)];
var DrakkarSpawn = getZone(99);
var TownHall = getZone(95);
var SPAWNCOOLDOWN = 28.00;
var PUSHCOOLDOWN = 1.13;
var CHIEFCOOLDOWN = 5.17;
var LORECOOLDOWN = 2.17;
var WAVECOOLDOWN = 3.13;
var JottunCamp = getZone(87);
var UndeadPath = [getZone(83), getZone(76)];
var Leader;
spawnTimer = 0.0;
waveTimer = 0.0;
loreTimer = 0.0;
chiefTimer = 0.0;
pushTimer = 0.0;

approvalTimer = 20.0;

waveBool = true;



// --- Script code ---
function init() {
	state.objectives.add("happy", "Attract adventurers to your village by managing your village's happiness.");
	state.objectives.add("warchief", "Build your [Fame] through feasts and building upgrades to summon powerful adventurers.");
	state.objectives.add("upgrades", "Upgrading certain buildings will unlock [Lore] to further improve your village.");
	state.objectives.add("halvard", "Gain Influence to call the mighty [Hero06] to your defense.");
	state.objectives.add("goal", "Survive [LichKing]'s assault until year 805!");
	for (player in state.players) {
		Leader = player;
		}
	if (state.time == 0)
		onFirstLaunch();
	onEachLaunch();
}



function onFirstLaunch() {
	addRules();
	noExpansion();
	removeVictories();
	noEvent();
}

function onEachLaunch() {



}

// Regular update is called every 0.5s
function regularUpdate(dt : Float) {

	undeadPush();
	getLore();

	approvalRating();
	happyVisitors();


	if ((state.time / 185) > niflheimAttack) {
			niflheimAttack += 1.0;
			niflheimWave();
	}
	if (!cooldownCheck(chiefTimer, CHIEFCOOLDOWN)) return; chiefTimer = state.time;
		fameWarchief1();
		fameWarchief2();
		fameWarchief3();
		summonHalvard();


}

function addRules() { {
	addRule(Rule.NoResourceLore);
	}
}

function niflheimWave() {
	if (!cooldownCheck(waveTimer, WAVECOOLDOWN)) return; waveTimer = state.time;
		if (niflheimAttack == 2) {
			launchAttack(Niflheim[0].addUnit(Unit.Death, 2), Village);
			launchAttack(Niflheim[1].addUnit(Unit.Death, 2), Village);
			sfx(UiSfx.Horn);
		}
		else if (niflheimAttack == 3) {
			launchAttack(Niflheim[0].addUnit(Unit.Death, 2), Village);
			launchAttack(Niflheim[0].addUnit(Unit.Wolf, 2), Village);
			launchAttack(Niflheim[1].addUnit(Unit.Death, 2), Village);
			launchAttack(Niflheim[1].addUnit(Unit.Wolf, 2), Village);
			sfx(UiSfx.Horn);
		}
		else if (niflheimAttack == 4) {
			launchAttack(Niflheim[0].addUnit(Unit.Death, 2), Village);
			launchAttack(Niflheim[0].addUnit(Unit.WhiteWolf, 2), Village);
			launchAttack(Niflheim[1].addUnit(Unit.Death, 2), Village);
			launchAttack(Niflheim[1].addUnit(Unit.WhiteWolf, 2), Village);
			sfx(UiSfx.Horn);

		}
		else if (niflheimAttack == 5) {
			launchAttack(Niflheim[0].addUnit(Unit.Wolf, 2), Village);
			launchAttack(Niflheim[0].addUnit(Unit.Valkyrie, 2), Village);
			launchAttack(Niflheim[1].addUnit(Unit.Wolf, 2), Village);
			launchAttack(Niflheim[1].addUnit(Unit.Valkyrie, 2), Village);
			sfx(UiSfx.Horn);
		}
		else if (niflheimAttack == 6) {
			launchAttack(Niflheim[0].addUnit(Unit.GiantCrow, 2), Village);
			launchAttack(Niflheim[1].addUnit(Unit.GiantCrow, 2), Village);
			sfx(UiSfx.GiantRaid, 0.5);
			sfx(UiSfx.Horn);
		}
		else if (niflheimAttack == 7) {
			launchAttack(Niflheim[0].addUnit(Unit.Death, 2), Village);
			launchAttack(Niflheim[0].addUnit(Unit.WhiteWolf, 3), Village);
			launchAttack(Niflheim[0].addUnit(Unit.Valkyrie, 2), Village);
			launchAttack(Niflheim[1].addUnit(Unit.Death, 2), Village);
			launchAttack(Niflheim[1].addUnit(Unit.WhiteWolf, 3), Village);
			launchAttack(Niflheim[1].addUnit(Unit.Valkyrie, 2), Village);
			addRule(Rule.ZombieDraugr);
			sfx(UiSfx.Horn);
		}
		else if (niflheimAttack == 8) {
			launchAttack(Niflheim[0].addUnit(Unit.Wolf, 3), Village);
			launchAttack(Niflheim[0].addUnit(Unit.Death, 3), Village);
			launchAttack(Niflheim[0].addUnit(Unit.Valkyrie, 2), Village);
			launchAttack(Niflheim[1].addUnit(Unit.Wolf, 3), Village);
			launchAttack(Niflheim[1].addUnit(Unit.Death, 3), Village);
			launchAttack(Niflheim[1].addUnit(Unit.Valkyrie, 2), Village);
			sfx(UiSfx.Horn);

		}
		else if (niflheimAttack == 9) {
			launchAttack(Niflheim[0].addUnit(Unit.Death, 4), Village);
			launchAttack(Niflheim[0].addUnit(Unit.Wolf, 4), Village);
			launchAttack(Niflheim[0].addUnit(Unit.Bear, 2), Village);
			launchAttack(Niflheim[1].addUnit(Unit.Death, 4), Village);
			launchAttack(Niflheim[1].addUnit(Unit.Wolf, 4), Village);
			launchAttack(Niflheim[1].addUnit(Unit.Bear, 2), Village);
			sfx(UiSfx.Horn);
		}
		else if (niflheimAttack == 12) {
			launchAttack(Niflheim[0].addUnit(Unit.GiantCrow, 4), Village);
			launchAttack(Niflheim[1].addUnit(Unit.GiantCrow, 4), Village);
			sfx(UiSfx.GiantRaid, 0.5);
			sfx(UiSfx.Horn);
		}
		else if (niflheimAttack == 10) {
			launchAttack(Niflheim[0].addUnit(Unit.Valkyrie, 2), Village);
			launchAttack(Niflheim[0].addUnit(Unit.Death, 3), Village);
			launchAttack(Niflheim[0].addUnit(Unit.UndeadGiant, 1), Village);
			launchAttack(Niflheim[1].addUnit(Unit.Valkyrie, 2), Village);
			launchAttack(Niflheim[1].addUnit(Unit.Death, 3), Village);
			launchAttack(Niflheim[1].addUnit(Unit.UndeadGiant, 1), Village);
			sfx(UiSfx.Horn);
		}
		else if (niflheimAttack == 11) {
			launchAttack(Niflheim[0].addUnit(Unit.WhiteWolf, 4), Village);
			launchAttack(Niflheim[0].addUnit(Unit.Death, 3), Village);
			launchAttack(Niflheim[0].addUnit(Unit.UndeadGiant, 1), Village);
			launchAttack(Niflheim[1].addUnit(Unit.WhiteWolf, 4), Village);
			launchAttack(Niflheim[1].addUnit(Unit.Death, 3), Village);
			launchAttack(Niflheim[1].addUnit(Unit.UndeadGiant, 1), Village);
			sfx(UiSfx.Horn);
		}
		else if (niflheimAttack == 13) {
			launchAttack(Niflheim[0].addUnit(Unit.Death, 4), Village);
			launchAttack(Niflheim[0].addUnit(Unit.Valkyrie, 3), Village);
			launchAttack(Niflheim[0].addUnit(Unit.UndeadGiant, 1), Village);
			launchAttack(Niflheim[1].addUnit(Unit.Death, 4), Village);
			launchAttack(Niflheim[1].addUnit(Unit.Valkyrie, 3), Village);
			launchAttack(Niflheim[1].addUnit(Unit.UndeadGiant, 1), Village);
			sfx(UiSfx.Horn);
		}
			else if (niflheimAttack == 14) {
			launchAttack(Niflheim[0].addUnit(Unit.Wolf, 4), Village);
			launchAttack(Niflheim[0].addUnit(Unit.Death, 4), Village);
			launchAttack(Niflheim[0].addUnit(Unit.Valkyrie, 3), Village);
			launchAttack(Niflheim[0].addUnit(Unit.UndeadGiant, 1), Village);
			launchAttack(Niflheim[1].addUnit(Unit.Wolf, 4), Village);
			launchAttack(Niflheim[1].addUnit(Unit.Valkyrie, 3), Village);
			launchAttack(Niflheim[1].addUnit(Unit.Death, 4), Village);
			launchAttack(Niflheim[1].addUnit(Unit.UndeadGiant, 1), Village);
			sfx(UiSfx.Horn);
		}
		else if (niflheimAttack == 18) {
			launchAttack(Niflheim[0].addUnit(Unit.UndeadGiant, 2), Village);
			launchAttack(Niflheim[0].addUnit(Unit.Wolf, 5), Village);
			launchAttack(Niflheim[0].addUnit(Unit.Death, 5), Village);
			launchAttack(Niflheim[0].addUnit(Unit.Valkyrie, 3), Village);
			launchAttack(Niflheim[1].addUnit(Unit.UndeadGiant, 2), Village);
			launchAttack(Niflheim[1].addUnit(Unit.Wolf, 5), Village);
			launchAttack(Niflheim[1].addUnit(Unit.Death, 5), Village);
			launchAttack(Niflheim[1].addUnit(Unit.Valkyrie, 3), Village);
			sfx(UiSfx.Horn);
		}
		else if (niflheimAttack == 15) {
			launchAttack(Niflheim[0].addUnit(Unit.WhiteWolf, 4), Village);
			launchAttack(Niflheim[0].addUnit(Unit.Death, 4), Village);
			launchAttack(Niflheim[0].addUnit(Unit.WhiteBear, 2), Village);
			launchAttack(Niflheim[0].addUnit(Unit.Valkyrie, 3), Village);
			launchAttack(Niflheim[1].addUnit(Unit.WhiteWolf, 4), Village);
			launchAttack(Niflheim[1].addUnit(Unit.Death, 4), Village);
			launchAttack(Niflheim[1].addUnit(Unit.WhiteBear, 2), Village);
			launchAttack(Niflheim[1].addUnit(Unit.Valkyrie, 3), Village);
			sfx(UiSfx.Horn);
		}
		else if (niflheimAttack == 16) {
			launchAttack(Niflheim[0].addUnit(Unit.UndeadGiant, 2), Village);
			launchAttack(Niflheim[0].addUnit(Unit.Death, 4), Village);
			launchAttack(Niflheim[0].addUnit(Unit.Valkyrie, 3), Village);
			launchAttack(Niflheim[1].addUnit(Unit.UndeadGiant, 2), Village);
			launchAttack(Niflheim[1].addUnit(Unit.Death, 4), Village);
			launchAttack(Niflheim[1].addUnit(Unit.Valkyrie, 3), Village);
			sfx(UiSfx.Horn);
		}
		else if (niflheimAttack == 17) {
			launchAttack(Niflheim[0].addUnit(Unit.UndeadGiant, 2), Village);
			launchAttack(Niflheim[0].addUnit(Unit.Wolf, 3), Village);
			launchAttack(Niflheim[0].addUnit(Unit.Death, 4), Village);
			launchAttack(Niflheim[0].addUnit(Unit.Valkyrie, 3), Village);
			launchAttack(Niflheim[1].addUnit(Unit.UndeadGiant, 2), Village);
			launchAttack(Niflheim[1].addUnit(Unit.Wolf, 3), Village);
			launchAttack(Niflheim[1].addUnit(Unit.Death, 4), Village);
			launchAttack(Niflheim[1].addUnit(Unit.Valkyrie, 3), Village);
			sfx(UiSfx.Horn);
		}
		else if (niflheimAttack == 19) {
			launchAttack(Niflheim[0].addUnit(Unit.IceGolem, 3), Village);
			launchAttack(Niflheim[0].addUnit(Unit.Death, 5), Village);
			launchAttack(Niflheim[0].addUnit(Unit.Valkyrie, 4), Village);
			launchAttack(Niflheim[1].addUnit(Unit.IceGolem, 3), Village);
			launchAttack(Niflheim[1].addUnit(Unit.Death, 5), Village);
			launchAttack(Niflheim[1].addUnit(Unit.Valkyrie, 4), Village);
			sfx(UiSfx.Horn);
		}
		else if (niflheimAttack == 20) {
		player.customVictory("You've defended your village from the undead legions!", "Get wrecked Valdemarr");
		}


}
function sendAdventurer() {

	launchAttack(AdventureSpawn[0].addUnit(Unit.Mercenary, 1, Leader), [91]);
	launchAttack(AdventureSpawn[1].addUnit(Unit.Mercenary, 1, Leader), [84]);

}


function getLore() {
	if (!cooldownCheck(loreTimer, LORECOOLDOWN)) return; loreTimer = state.time;
			if (Leader.hasBuilding(Building.Sheepfold, false, true)) {
				Leader.unlockTech(Tech.Coats);
				Leader.unlockTech(Tech.SlotWealth);
			}
			if (Leader.hasBuilding(Building.Forge, false, true)) {
				Leader.unlockTech(Tech.Heroes);
				Leader.unlockTech(Tech.FreeTools);
			}
			if (Leader.hasBuilding(Building.TradingPost, false, true)) {
				Leader.unlockTech(Tech.Coinage, false);
				Leader.discoverZone(JottunCamp);
			}
			if (Leader.hasBuilding(Building.WoodLodge, false, true)) {
				Leader.unlockTech(Tech.MoreBuildings);
				Leader.unlockTech(Tech.Drakkars);
			}
			if (Leader.hasBuilding(Building.House, false, true)) {
				Leader.unlockTech(Tech.HeartStone);
				Leader.unlockTech(Tech.Security);
			}
		}


function undeadPush() {
	if (!cooldownCheck(pushTimer, PUSHCOOLDOWN)) return; pushTimer = state.time;
		if (getZone(Village[0]).owner == null) {
		launchAttack(getZone(Village[0]).units.copy(), [95]);
	}
		if (getZone(Village[1]).owner == null) {
		launchAttack(getZone(Village[1]).units.copy(), [95]);
	}
}


function fameWarchief1() {
	if (Leader.getResource(Resource.Fame) >= 100 && chief == 1) {
		drakkar(Leader, TownHall, DrakkarSpawn, 0, 2, [Unit.Hero01], .10);
				sfx(UiSfx.CallToArms, 0.5);
					chief++;
			}
		}

function fameWarchief2() {
	if (Leader.getResource(Resource.Fame) >= 250 && chief == 2) {
		drakkar(Leader, TownHall, DrakkarSpawn, 0, 2, [Unit.Hero02], .10);
			sfx(UiSfx.CallToArms, 0.5);
				chief++;
			}
		}

function fameWarchief3() {
	if (Leader.getResource(Resource.Fame) >= 400 && chief == 3) {
		drakkar(Leader, TownHall, DrakkarSpawn, 0, 2, [Unit.WarchiefDragon], .10);
				sfx(UiSfx.CallToArms, 0.5);
				chief++;
			}
		}


function summonHalvard() {
	if (Leader.getResource(Resource.Prestige) >= 400 && halvard == 1) {
		drakkar(Leader, TownHall, DrakkarSpawn, 0, 2, [Unit.Hero06], .10);
			Leader.unlockTech(Tech.MonsterSlayer);
				sfx(UiSfx.CallToArms);
				talk("Let's send these creatures back to Helheim!", {name:"Halvard", who:Banner.BannerGoat});
					halvard++;
			}
		}


function noExpansion() {
	Leader.allowColonize(UndeadPath[1], false);
	Leader.allowColonize(UndeadPath[0], false);
	}


function happyVisitors() {
	if (approvalTimer >= 60) {
		sendAdventurer();
		approvalTimer = 0.0;
	}

}

function approvalRating() {
	var Approval = Leader.getHappiness();
		if (Approval >= 8.5) {
			approvalTimer += 2.275;
	} else
		if (Approval >= 7.5 && Approval < 8.5) {
			approvalTimer += 2.0;
	} else
		if (Approval >= 6.5 && Approval < 7.5) {
			approvalTimer += 1.5;
	} else
		if (Approval >= 5 && Approval < 6.5) {
			approvalTimer += 1.25;
	} else
		if (Approval >= 4 && Approval < 5) {
			approvalTimer += 0.95;
	} else
		if (Approval >= 3 && Approval < 4) {
			approvalTimer += 0.85;
	} else
		if (Approval >= 2 && Approval < 3) {
			approvalTimer += 0.75;
	} else
		if (Approval < 2 && Approval > 0) {
			approvalTimer += 0.675;
	} else
		if (Approval <= 0) {
			approvalTimer += 0.0;
		}
}


function cooldownCheck(last : Float, cooldown : Float) : Bool {
	if( (last + cooldown) < state.time )
	{
		return true;

	}
	return false;
}

function removeVictories() {
	state.removeVictory(Victory.Fame);
	state.removeVictory(Victory.Money);
	state.removeVictory(Victory.Lore);
}